
' ROT-13 demo, code provided by Vic Drastik

'> "The simple Caesar-cypher encryption that replaces each English letter
'> with the one 13 places forward or back along the alphabet, so that
'> "The butler did it!" becomes "Gur ohgyre qvq vg!".
'> Most Usenet news reading and posting programs include a rot13 feature.
'> It is used to enclose the text in a sealed wrapper that the reader
'> must choose to open -- e.g., for posting things that might offend some
'> readers, or spoilers.
'> A major advantage of rot13 over rot(N) for other N is that it is
'> self-inverse, so the same code can be used for encoding and decoding.
'> See also spoiler space, which has partly displaced rot13 since
'> non-Unix-based newsreaders became common."

VERSION "0.0001"
CONSOLE

IMPORT "xst"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION STRING Rot13 (STRING s)

FUNCTION Entry ()

	s$ = "The butler did it!"
	enc$ =  Rot13 (s$)
	? enc$
	s$ =  Rot13 (enc$)
	? s$

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION STRING Rot13 (STRING s)
STRING t

	IFZ s THEN RETURN ""
	t = s
	FOR i = 0 TO UBOUND(t)
		c = t{i}
		t{i} =  c + 13*(-(c>64)+2*(c>77)-(c>90)-(c>96)+2*(c>109)-(c>122))
	NEXT i

RETURN t
END FUNCTION
END PROGRAM