'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Rudimentary long double math library.
'
PROGRAM	"xml"
VERSION	"0.0003"
CONSOLE

'IMPORT	"xst"
EXPORT
DECLARE FUNCTION  VOID        Xml   ()
DECLARE FUNCTION  LONGDOUBLE  SqrtL (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  PiL   ()
DECLARE FUNCTION  LONGDOUBLE  Ln2L  ()
DECLARE FUNCTION  LONGDOUBLE  Log2L ()
DECLARE FUNCTION  LONGDOUBLE  SinL  (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  CosL  (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  TanL  (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  Log10L  (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  LogL   (LONGDOUBLE xld)
DECLARE FUNCTION  LONGDOUBLE  ExpL (LONGDOUBLE xld)
DECLARE FUNCTION LONGDOUBLE AtanL (LONGDOUBLE xld)
END EXPORT
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  VOID Xml ()

	IF LIBRARY (0) THEN RETURN

	PRINT PiL()
	PRINT Log2L()
	PRINT Ln2L ()

	PRINT SqrtL(2##), SqrtL(100.0##)

	PRINT SinL (45.0## * PiL() / 180##)
	PRINT CosL (45.0## * PiL() / 180##)
	PRINT TanL (45.0## * PiL() / 180##)

	PRINT Log10L (10.0##)
	PRINT Log10L (2.0##)
	PRINT Log10L (1000##)

	PRINT LogL (2.0##)
	PRINT LogL (1000##)

	PRINT AtanL(45##)

	PRINT ExpL(45##)


'	a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
'
'
' ######################
' #####  SqrtL ()  #####
' ######################
'
' Compute the square root of a long double value
'
FUNCTION  LONGDOUBLE SqrtL (LONGDOUBLE xld)

	LONGDOUBLE sqrt

ASM	fld	  t[SqrtL.xld]
ASM	fsqrt
ASM	fstp	t[SqrtL.sqrt]

	RETURN sqrt

END FUNCTION
'
'
' ####################
' #####  PiL ()  #####
' ####################
'
' Return value for Pi.
'
FUNCTION  LONGDOUBLE PiL ()

	LONGDOUBLE pi

ASM	fldpi												; load pi into st(0)
ASM	fstp	t[PiL.pi]

	RETURN pi

END FUNCTION
'
'
' ######################
' #####  Log2L ()  #####
' ######################
'
' Return value for the log base 10 of 2 (log(2)).
'
FUNCTION  LONGDOUBLE Log2L ()

	LONGDOUBLE log2

ASM	fldlg2												; load log(2) into st(0)
ASM	fstp	t[Log2L.log2]

	RETURN log2

END FUNCTION
'
'
' ######################
' #####  Ln2L ()  #####
' ######################
'
' Return value for the natural log base e of 2 (ln(2)).
'
FUNCTION  LONGDOUBLE Ln2L ()

	LONGDOUBLE ln2

ASM	fldln2												; load ln(2) into st(0)
ASM	fstp	t[Ln2L.ln2]

	RETURN ln2

END FUNCTION
'
'
' #####################
' #####  SinL ()  #####
' #####################
'
' Compute the sine of a long double value in radians
'
FUNCTION  LONGDOUBLE SinL (LONGDOUBLE xld)

	LONGDOUBLE sin

ASM	fld	  t[SinL.xld]
ASM	fsin
ASM	fstp	t[SinL.sin]

	RETURN sin

END FUNCTION
'
'
' #####################
' #####  CosL ()  #####
' #####################
'
' Compute the cosine of a long double value in radians
'
FUNCTION  LONGDOUBLE CosL (LONGDOUBLE xld)

	LONGDOUBLE cos

ASM	fld	  t[CosL.xld]
ASM	fcos
ASM	fstp	t[CosL.cos]

	RETURN cos

END FUNCTION
'
'
' #####################
' #####  TanL ()  #####
' #####################
'
' Compute the tangent of a long double value in radians
'
FUNCTION  LONGDOUBLE TanL (LONGDOUBLE xld)

	LONGDOUBLE tan

ASM	fld	  t[TanL.xld]
ASM	fptan											; ST(0)=1.0, ST(1)=tan(rad)
ASM	fstp	st0       				  ; this pops the TOP register, ST(0)=tan(rad)
ASM	fstp	t[TanL.tan]

	RETURN tan

END FUNCTION
'
'
' #####################
' #####  LogL ()  #####
' #####################
'
' Compute the common log base 10 of a long double value (log10(x)).
'
FUNCTION  LONGDOUBLE Log10L (LONGDOUBLE xld)

	LONGDOUBLE log

ASM	fldlg2         					; ST(0)=log10(2), ST(1)=zzz
ASM	fld  		t[Log10L.xld]		; ST(0)=xld, ST(1)=log10(2), ST(2)=zzz
ASM	fyl2x          					; log2(xld)*log10(2)=>ST(1) and ST(0) is POPed
'               						; ST(0)=log10(xld), ST(1)=zzz
ASM	fstp		t[Log10L.log]

	RETURN log

END FUNCTION
'
'
' #####################
' #####  LnL ()  #####
' #####################
'
' Compute the natural log of a long double value (log(x)).
'
FUNCTION  LONGDOUBLE LogL (LONGDOUBLE xld)

	LONGDOUBLE ln

ASM	fldln2         					; ST(0)=ln(2), ST(1)=zzz
ASM	fld  		t[LogL.xld]			; ST(0)=xld, ST(1)=ln(2), ST(2)=zzz
ASM	fyl2x          					; log2(xld)*ln(2)=>ST(1) and ST(0) is POPed
'               						; ST(0)=log10(xld), ST(1)=zzz
ASM	fstp		t[LogL.ln]

	RETURN ln

END FUNCTION
'
' ###################
' #####  AtanL  #####
' ###################
'
FUNCTION LONGDOUBLE AtanL (LONGDOUBLE xld)
LONGDOUBLE ln

ASM	fld	  t[AtanL.xld]		; get param on stack
ASM fld1							    ; ST(0)=1.0,ST(1)=param
ASM	fpatan						    ; compute atan(ST(1)),divide by ST(0) and pop ST(0) so ST(0)=atan(rad)
ASM	fstp	t[AtanL.ln]	    ; write result on ln

	RETURN ln

END FUNCTION
'
' ##################
' #####  ExpL  #####
' ##################
'
'
FUNCTION LONGDOUBLE ExpL (LONGDOUBLE xld)
LONGDOUBLE ln

ASM fld t[ExpL.xld]				; get param on stack

ASM fldl2e                ; Load log base 2(e)
ASM fmulp   st1,st0       ; Multiply x * log base 2(e)
ASM fst     st1           ; Push result
ASM frndint               ; Round to integer
ASM fsub    st1,st0       ; Subtract
ASM fxch                  ; Exchange st, st(1)
ASM f2xm1                 ; Compute 2 to the (x - 1)
ASM fld1                  ; Load real number 1
ASM fadd                  ; 2 to the x
ASM fscale                ; Scale by power of 2
ASM fstp    st1           ; Set new stack top and pop


ASM fstp t[ExpL.ln]        ; write result on ln

	RETURN ln
END FUNCTION

END PROGRAM
